#include <sys/types.h>
#include "config.h"
#ifdef HAVE_LIBWRAP
#include <tcpd.h>
#endif

#include "defs.h"
#include "xmodule.h"
#include "service.h"
#include "sconf.h"
#include "msg.h"

status_e xinetd_sm_register(struct service *sp, struct module_conf *mc, connection_s *cp, void **arg)
{
	return OK;
}

status_e xinetd_sm_connect(struct service *sp, struct module_conf *mc, connection_s *cp, void **arg)
{
#ifdef HAVE_LIBWRAP
	struct request_info req;
	struct service_config *scp = sp->svc_conf;
	char *server = NULL;

	if( SC_NOLIBWRAP( sp->svc_conf ) ) 
		return OK;

	if( SC_NAMEINARGS( scp ) )
		server = strrchr( scp->sc_server_argv[0], '/' );
	else {
		if( scp->sc_server == NULL ) {
		/* probably an internal server, use the service id instead */
			server = scp->sc_id;
			server--;  /* nasty.  we increment it later... */
		} else {
			server = strrchr( scp->sc_server, '/' );
		}
	}

	/* If this is a redirection, go by the service name,
	 * since the server name will be bogus.
	 */
	if( scp->sc_redir_addr != NULL ) {
		server = scp->sc_name;
		server--; /* nasty but ok. */
	}

	if( server == NULL )
		server = scp->sc_server_argv[0];
	else
		server++;

	request_init(&req, RQ_DAEMON, server, RQ_FILE, cp->co_descriptor, 0);
	fromhost(&req);
	if (!hosts_access(&req)) {
		msg(deny_severity, "libwrap.so", "libwrap refused connection to %s from %s", SC_ID(scp), conn_addrstr(cp));
		return(FAILED);
	}
#endif /* HAVE_LIBWRAP */

	return OK;
}
